# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***
# Resource specification version: 31.1.0


from . import AWSObject
from . import AWSProperty
from troposphere import Tags
from .validators import integer


class ExpiryEventsConfiguration(AWSProperty):
    props = {
        'DaysBeforeExpiry': (integer, False),
    }


class Account(AWSObject):
    resource_type = "AWS::CertificateManager::Account"

    props = {
        'ExpiryEventsConfiguration': (ExpiryEventsConfiguration, True),
    }


class DomainValidationOption(AWSProperty):
    props = {
        'DomainName': (basestring, True),
        'HostedZoneId': (basestring, False),
        'ValidationDomain': (basestring, False),
    }


class Certificate(AWSObject):
    resource_type = "AWS::CertificateManager::Certificate"

    props = {
        'CertificateAuthorityArn': (basestring, False),
        'CertificateTransparencyLoggingPreference': (basestring, False),
        'DomainName': (basestring, True),
        'DomainValidationOptions': ([DomainValidationOption], False),
        'SubjectAlternativeNames': ([basestring], False),
        'Tags': ((Tags, list), False),
        'ValidationMethod': (basestring, False),
    }
