# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***
# Resource specification version: 31.0.0


from . import AWSObject
from . import AWSProperty
from troposphere import Tags


class EksInfo(AWSProperty):
    props = {
        'Namespace': (basestring, True),
    }


class ContainerInfo(AWSProperty):
    props = {
        'EksInfo': (EksInfo, True),
    }


class ContainerProvider(AWSProperty):
    props = {
        'Id': (basestring, True),
        'Info': (ContainerInfo, True),
        'Type': (basestring, True),
    }


class VirtualCluster(AWSObject):
    resource_type = "AWS::EMRContainers::VirtualCluster"

    props = {
        'ContainerProvider': (ContainerProvider, True),
        'Name': (basestring, True),
        'Tags': (Tags, False),
    }
