# Copyright (c) 2012-2019, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***
# Resource specification version: 16.1.0


from . import AWSObject
from . import AWSProperty
from troposphere import Tags
from .validators import boolean


class Ledger(AWSObject):
    resource_type = "AWS::QLDB::Ledger"

    props = {
        'DeletionProtection': (boolean, False),
        'Name': (basestring, False),
        'PermissionsMode': (basestring, True),
        'Tags': (Tags, False),
    }


class KinesisConfiguration(AWSProperty):
    props = {
        'AggregationEnabled': (boolean, False),
        'StreamArn': (basestring, False),
    }


class Stream(AWSObject):
    resource_type = "AWS::QLDB::Stream"

    props = {
        'ExclusiveEndTime': (basestring, False),
        'InclusiveStartTime': (basestring, True),
        'KinesisConfiguration': (KinesisConfiguration, True),
        'LedgerName': (basestring, True),
        'RoleArn': (basestring, True),
        'StreamName': (basestring, True),
        'Tags': (Tags, False),
    }
