# Copyright (c) 2012-2020, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***
# Resource specification version: 18.6.0


from . import AWSObject
from . import AWSProperty
from troposphere import Tags
from .validators import boolean
from .validators import integer


class ConnectionAlias(AWSObject):
    resource_type = "AWS::WorkSpaces::ConnectionAlias"

    props = {
        'ConnectionString': (basestring, True),
        'Tags': (Tags, False),
    }


class WorkspaceProperties(AWSProperty):
    props = {
        'ComputeTypeName': (basestring, False),
        'RootVolumeSizeGib': (integer, False),
        'RunningMode': (basestring, False),
        'RunningModeAutoStopTimeoutInMinutes': (integer, False),
        'UserVolumeSizeGib': (integer, False),
    }


class Workspace(AWSObject):
    resource_type = "AWS::WorkSpaces::Workspace"

    props = {
        'BundleId': (basestring, True),
        'DirectoryId': (basestring, True),
        'RootVolumeEncryptionEnabled': (boolean, False),
        'Tags': (Tags, False),
        'UserName': (basestring, True),
        'UserVolumeEncryptionEnabled': (boolean, False),
        'VolumeEncryptionKey': (basestring, False),
        'WorkspaceProperties': (WorkspaceProperties, False),
    }
